#include "defs.h"
                   /* +-------------------------+
                      |  Addition/soustraction  |
                      +-------------------------+ */


/* c <- a + b, retourne la retenue */
chiffre add(chiffre *c, chiffre *a, chiffre *b, longueur la, longueur lb) {
  longueur i;
  ndouble r;

  if (la < lb) {chiffre *x; longueur l; x=a; a=b; b=x; l=la; la=lb; lb=l;}
  for (i=0,r=0; i < lb; i++) {r += aa(i) + bb(i); c[i] = r; r >>= shift;}
  for (;        i < la; i++) {r += aa(i);         c[i] = r; r >>= shift;}
  return(r);
}

/* a <- a+b, retourne la retenue */
chiffre inc(chiffre *a, chiffre *b, longueur la, longueur lb) {
  longueur i;
  ndouble r;

  for (i=0,r=0; i < lb;   i++) {r += aa(i) + bb(i); a[i] = r; r >>= shift;}
  for (; (r) && (i < la); i++) {a[i]++; r = (aa(i) == 0);}
  return(r);
}

/* c <- a - b, retourne la retenue */
zdouble sub(chiffre *c, chiffre *a, chiffre *b, longueur la, longueur lb) {
  longueur i;
  zdouble r;

  for (i=0,r=0; i < lb; i++) {r += aa(i) - bb(i); c[i] = r; r = (r<0) ? -1 : 0;}
  for (;        i < la; i++) {r += aa(i);         c[i] = r; r = (r<0) ? -1 : 0;}
  return(r);
}

/* a <- a - b, retourne la retenue */
zdouble dec(chiffre *a, chiffre *b, longueur la, longueur lb) {
  longueur i;
  zdouble r;

  for (i=0,r=0; i < lb;   i++) {r += aa(i) - bb(i); a[i] = r; r = (r<0) ? -1 : 0;}
  for (; (r) && (i < la); i++) {r = (aa(i) == 0); a[i]--;}
  return((r) ? -1 : 0);
}

/* c <- |a-b|, retourne le signe */
int asub(chiffre *c, chiffre *a, chiffre *b, longueur la, longueur lb) {
  longueur i, lc = (la > lb) ? la : lb;
  zdouble r;
  int s;

  for (; (la > lb) && (aa(la-1) == 0); la--);
  for (; (lb > la) && (bb(lb-1) == 0); lb--);
  if (la == lb) for (; (la > 0) && (aa(la-1) == bb(lb-1)); la--,lb--);
  s = (la < lb) || ((la == lb) && (la > 0) && (aa(la-1) < bb(lb-1)));
  if (s) {chiffre *x; longueur l; x=a; a=b; b=x; l=la; la=lb; lb=l;}
 
  for (i=0,r=0; i < lb; i++) {r += aa(i) - bb(i); c[i] = r; r = (r<0) ? -1 : 0;}
  for (i=lb;    i < la; i++) {r += aa(i);         c[i] = r; r = (r<0) ? -1 : 0;}
  clearmem(c+la,lc-la);
  return(s);
}


              /* +-----------------------------------+
                 |  Addition/soustraction par blocs  |
                 +-----------------------------------+ */

/* c <- a + b, la,lb = nb de blocs */
void bloc_add(chiffre *c, chiffre *a, chiffre *b, longueur la, longueur lb, longueur n0) {
  longueur i,j;
  ndouble r;

  if (la < lb) {chiffre *x; longueur l; x=a; a=b; b=x; l=la; la=lb; lb=l;}
  for (i=0; i < lb; i++)
    for (j=0,r=0; j < n0; j++)
      {r += aa(i*n0+j) + bb(i*n0+j); c[i*n0+j] = r; r >>= shift;}
  movemem(c+i*n0, a+i*n0, (la-i)*n0);

}    

/* a <- a + b, la,lb = nb de blocs */
void bloc_inc(chiffre *a, chiffre *b, longueur la, longueur lb, longueur n0) {
  longueur i,j,l;
  ndouble r;

  l = (la < lb) ? la : lb;
  for (i=0; i < l; i++)
    for (j=0,r=0; j < n0; j++)
      {r += aa(i*n0+j) + bb(i*n0+j); a[i*n0+j] = r; r >>= shift;}
  movemem(a+i*n0, b+i*n0, (lb-i)*n0);

}    

/* c <- a - b, la,lb = nb de blocs */
void bloc_sub(chiffre *c, chiffre *a, chiffre *b, longueur la, longueur lb, longueur n0) {
  longueur i,j,l;
  zdouble r;

  l = (la < lb) ? la : lb;
  for (i=0; i < l; i++)
    for (j=0,r=0; j < n0; j++)
      {r += aa(i*n0+j) - bb(i*n0+j); c[i*n0+j] = r; r >>= shift;}
  movemem(c+i*n0, a+i*n0, (la-i)*n0);
  for (; i < lb; i++)
    for (j=0,r=0; j < n0; j++)
      {r -= bb(i*n0+j); c[i*n0+j] = r; r >>= shift;}

}    

/* a <- a - b, la,lb = nb de blocs */
void bloc_dec(chiffre *a, chiffre *b, longueur la, longueur lb, longueur n0) {
  longueur i,j,l;
  zdouble r;

  l = (la < lb) ? la : lb;
  for (i=0; i < l; i++)
    for (j=0,r=0; j < n0; j++)
      {r += aa(i*n0+j) - bb(i*n0+j); a[i*n0+j] = r; r >>= shift;}
  for (; i < lb; i++)
    for (j=0,r=0; j < n0; j++)
      {r -= bb(i*n0+j); a[i*n0+j] = r; r >>= shift;}

}    

               /* +--------------------------------+
                  |  Addition/soustraction mixtes  |
                  +--------------------------------+ */


/* a <- a+b, b dcompos en blocs positifs de longueur n0, dcalage n1 */
chiffre mix_inc(chiffre *a, chiffre *b, longueur la, longueur lb,
		longueur n0, longueur n1) {
  longueur i,l;
  chiffre r;

  for (r=0,i=0,l=la; (i<lb) && (l>0); i++, l-=n1)
    r += inc(a+i*n1,b+i*n0,l, (n0 < l) ? n0:l);
  return(r);
}

/* a <- a-b, dcompos en blocs positifs de longueur n0, dcalage n1 */
zdouble mix_dec(chiffre *a, chiffre *b, longueur la, longueur lb,
		longueur n0, longueur n1) {
  longueur i,l;
  zdouble r;

  for (r=0,i=0,l=la; (i<lb) && (l>0); i++, l-=n1)
    r += dec(a+i*n1,b+i*n0,l, (n0<l) ? n0:l);
  return(r);
}
    
    
