                  /* +--------------------------+
                     |  Dcomposition en blocs  |
                     +--------------------------+ */

#include "defs.h"

/* dcompose un nombre en blocs */
void expand(chiffre *b, chiffre *a, longueur la, longueur lb, longueur n0) {
  longueur p = (la+n0-1)/n0;
  longueur i,l;

  clearmem(b,lb*(n0+1));
  for (i=0; i < p; i++) {
    l = (i < p-1) ? n0 : (la-i*n0);
    movemem(b+i*(n0+1), a+i*n0, l);
  }
}

/* regroupe les blocs */
/* ne marche que si chaque bloc est positif */
void compact(chiffre *b, chiffre *a,
	     longueur la, /* nb de blocs       */
	     longueur n0, /* taille des blocs  */
	     longueur n1, /* dcalage          */
	     longueur lb) /* longueur rsultat */
{
  longueur i,l,n2,n3;
  chiffre r;

  if (la <= 0) clearmem(b,lb);
  else {
    /* copie le premier bloc */
    n2 = (lb < n0) ? lb : n0;
    movemem(b,a,n2);
    n2 -= n1;
    r = 0;
    
    /* ajoute les blocs suivants */
    for (i=1; i<la; i++) {
      a += n0;
      b += n1;
      lb-= n1;
      r += inc(b,a,n2,n2);
      n3 = (lb < n0) ? lb-n2 : n0-n2;
      if (n3 > 0) r  = add(b+n2,a+n2,&r,n3,1);
      n2+= n3-n1;
    }
  }
}
