                      /* +------------------+
                         |  Produit mdian  |
                         +------------------+ */


#include "defs.h"

/* c <- mdian(a*b), mthode 1 */
void bloc_rmp1(chiffre *c, chiffre *a, chiffre *b, longueur n, longueur n0) {
	
  if (n<=1) bloc_muln2(c,a,b,n,n0);

  else {
    longueur i,j,p=n/2;
    chiffre *buff  = getmem(3*p*n0);

    if (n%2) a+=n0;          /* n impair : calcule dj (u+u'):(v+v') */

    bloc_add(buff,      a,         a+p*n0,    n+p-1,n+p-1,n0);
    bloc_rmp1(c,        buff,      b+p*n0,    p,n0);       /* u' + v' */
    bloc_rmp1(c+2*p*n0, buff+p*n0, b,         p,n0);       /* u  + v  */
    bloc_sub(buff,      b+p*n0,    b,         p,p,n0);
    bloc_rmp1(buff+p*n0,a+p*n0,    buff,      p,n0);       /* u' - v  */
    bloc_dec(c,         buff+p*n0,            p,p,2*n0);   /* v  + v' */
    bloc_inc(c+2*p*n0,  buff+p*n0,            p,p,2*n0);   /* u  + u' */

    if (n%2) {                            /* n impair, ajoute w et w' */
      clearmem(c+4*p*n0,2*n0);
      a-=n0;
      for (i=0; i < n; i++) {
	bloc_muln2(buff, a+(2*n-2-i)*n0, b+i*n0, 1,n0);
	bloc_inc(c+4*p*n0, buff, 1,1,2*n0);
      }
      for (j=0; j < n-1; j++) {
	bloc_muln2(buff, a+j*n0, b+(n-1)*n0, 1,n0);
	bloc_inc(c+2*j*n0, buff, 1,1,2*n0);
      }
    }

    freemem(buff);
  }
}

/* c <- mdian(a*b), mthode 2 */
void bloc_rmp2(chiffre *c, chiffre *a, chiffre *b, longueur n, longueur n0) {
	
  if (n<=1) bloc_muln2(c,a,b,n,n0);

  else if (n%2 == 0) {
    longueur p=n/2;
    chiffre *buff  = getmem(3*p*n0);

    bloc_add(buff,      a,         a+p*n0,    n+p-1,n+p-1,n0);
    bloc_rmp2(c,        buff,      b+p*n0,    p,n0);       /* u' + v' */
    bloc_rmp2(c+2*p*n0, buff+p*n0, b,         p,n0);       /* u  + v  */
    bloc_sub(buff,      b+p*n0,    b,         p,p,n0);
    bloc_rmp2(buff+p*n0,a+p*n0,    buff,      p,n0);       /* u' - v  */
    bloc_dec(c,         buff+p*n0,            p,p,2*n0);   /* v  + v' */
    bloc_inc(c+2*p*n0,  buff+p*n0,            p,p,2*n0);   /* u  + u' */

    freemem(buff);
  }

  else {
    longueur p=(n+1)/2;
    chiffre *buff = getmem((5*p-1)*n0);
    chiffre *c1   = buff+(3*p-1)*n0;

    bloc_add(buff,      a,         a+p*n0,     3*p-1,3*p-3,n0);
    bloc_rmp2(c,        buff,      b+(p-1)*n0, p,n0);      /* u' + v' */
    clearmem(buff, n0);                        /* prolonge b  gauche */
    movemem(buff+n0,    b,                 (p-1)*n0);
    bloc_rmp2(c1,       buff+p*n0, buff,       p,n0);      /* u  + v  */
    movemem(c+2*p*n0,   c1,              2*(p-1)*n0);
    movemem(buff,       b+(p-1)*n0,              n0);
    bloc_sub(buff+n0,   b+p*n0,    b,    p-1,p-1,n0);
    bloc_rmp2(c1,       a+p*n0,    buff,       p,n0);      /* u' - v  */
    bloc_dec(c,         c1,                p,p,2*n0);      /* v  + v' */
    bloc_inc(c+2*p*n0,  c1,            p-1,p-1,2*n0);      /* u  + u' */

    freemem(buff);
  }
}

/* c <- mdian(a*b), mthode 3 */
void bloc_rmp3(chiffre *c, chiffre *a, chiffre *b, longueur n, longueur n0) {
	
  if (n<=1) bloc_muln2(c,a,b,n,n0);

  else if (n%2 == 0) {
    longueur p=n/2;
    chiffre *buff  = getmem(3*p*n0);

    bloc_add(buff,      a,         a+p*n0,    n+p-1,n+p-1,n0);
    bloc_rmp2(c,        buff,      b+p*n0,    p,n0);       /* u' + v' */
    bloc_rmp2(c+2*p*n0, buff+p*n0, b,         p,n0);       /* u  + v  */
    bloc_sub(buff,      b+p*n0,    b,         p,p,n0);
    bloc_rmp2(buff+p*n0,a+p*n0,    buff,      p,n0);       /* u' - v  */
    bloc_dec(c,         buff+p*n0,            p,p,2*n0);   /* v  + v' */
    bloc_inc(c+2*p*n0,  buff+p*n0,            p,p,2*n0);   /* u  + u' */

    freemem(buff);
  }

  else {
    longueur i,p=n/2;
    chiffre *buff = getmem((3*p+3)*n0);

    bloc_add(buff,      a,             a+p*n0, n+p,n+p,n0);
    bloc_rmp3(c,        buff,          b+p*n0,     p+1,n0); /* w':u':x' + x':v' */
    bloc_rmp3(c+2*p*n0, buff+(p+1)*n0, b,            p,n0); /* u:x + v */

    bloc_muln2(c+4*p*n0, buff+3*p*n0, b, 1,n0);             /* w + x */
    for (i=1; i < p; i++) { 
      bloc_muln2(buff, buff+(3*p-i)*n0, b+i*n0, 1,n0);
      bloc_inc(c+4*p*n0, buff, 1,1,2*n0);
    }

    bloc_sub(buff, b+p*n0, b, p,p,n0);                     /* w':u':x' - x:v */
    movemem(buff+p*n0, b+2*p*n0, n0);
    bloc_rmp3(buff+(p+1)*n0, a+p*n0, buff, p+1,n0);

    bloc_dec(c,        buff+(p+1)*n0, p,p,2*n0);           /* v + v' */
    bloc_inc(c+2*p*n0, buff+(p+1)*n0, p+1,p+1,2*n0);       /* w:u:x + w':u':x' */
    
    freemem(buff);
  }
}

/* c <- mdian tendu(a*b) */
void bloc_rmp4(int big, chiffre *c, chiffre *a, chiffre *b, longueur n, longueur n0) {

  if (n<=1) {
    bloc_muln2(c,a,b,n,n0);
    if (big) bloc_muln2(c+2*n0,a+n0,b,n,n0);
  }

  else if (n%2 == big) {
    longueur p=n/2, q=p+big;
    chiffre *buff  = getmem(3*q*n0);

    bloc_add(buff, a,        a+q*n0,     n+q-1,n+q-1,n0);
    bloc_rmp4(0,   c,        buff,      b+p*n0,    q,n0);       /* u' + v' */
    bloc_rmp4(big, c+2*q*n0, buff+q*n0, b,         p,n0);       /* u  + v  */
    if (big) {
      movemem(buff,     b+p*n0,         n0);
      bloc_sub(buff+n0, b+q*n0, b,  p,p,n0);
    } else {
      bloc_sub(buff,    b+p*n0, b,  p,p,n0);
    }
    bloc_rmp4(0,   buff+q*n0,a+q*n0,    buff,      q,n0);       /* u' - v  */
    bloc_dec(c,         buff+q*n0,            q,q,2*n0);        /* v  + v' */
    bloc_inc(c+2*q*n0,  buff+q*n0,            q,q,2*n0);        /* u  + u' */

    freemem(buff);
  }

  else {
    longueur i,p=n/2, q=p+1-big;
    chiffre *buff = getmem((3*p+3)*n0);

    bloc_add(buff, a,        a+p*n0, n+p,n+p,n0);
    bloc_rmp4(big, c,        buff,      b+p*n0,     q,n0); /* w':u':x' + x':v' */
    bloc_rmp4(1,   c+2*p*n0, buff+q*n0, b,          p,n0); /* w:u:x + x:v */
    if (big) {
      bloc_sub(buff, b+p*n0, b, p,p,n0);
    } else {
      bloc_sub(buff, b+p*n0, b, p,p,n0);  
      movemem(buff+p*n0, b+2*p*n0,  n0);
    }
    bloc_rmp4(big, buff+q*n0, a+p*n0, buff, q,n0);         /* w':u':x' - x:v */
    bloc_dec(c,        buff+q*n0, p,p,2*n0);               /* v + v' */
    bloc_inc(c+2*p*n0, buff+q*n0, p+1,p+1,2*n0);           /* w:u:x + w':u':x' */
    
    freemem(buff);
  }
}


/* c <- median(a*b), mthode 5 */
void bloc_rmp5(chiffre *c, chiffre *a, chiffre *b, longueur n, longueur n0) {

  if (n<=1) bloc_muln2(c,a,b,n,n0);
  else {
    longueur p=n/2, q=n-p;
    chiffre *buff = getmem(3*q*n0);

    bloc_add(buff,      a,         a+p*n0,   n+q-1,n+q-1,n0);
    bloc_rmp5(c,        buff,      b+q*n0,   p,n0);          /* u'   + v'    */
    bloc_rmp5(c+2*p*n0, buff+p*n0, b,        q,n0);          /* u:w  + w:v   */
    if (p<q) {
      movemem(buff, b, n0);
      bloc_sub(buff+n0, b+n0,      b+q*n0,   p,p,n0);
    } else {
      bloc_sub(buff,    b,         b+q*n0,   p,p,n0);
    }      
    bloc_rmp5(buff+q*n0,a+p*n0,    buff,     q,n0);          /* w:v  - w':u' */
    bloc_inc(c,         buff+q*n0,           p,p,2*n0);      /* v    + v'    */
    bloc_dec(c+2*p*n0,  buff+q*n0,           q,q,2*n0);      /* u:w  + w':u' */

    freemem(buff);
  }
}

/* c <- median(a*b) */
void rmp(int meth, chiffre *c, chiffre *a, chiffre *b, longueur n, longueur n0) {
  longueur n1,p;
  chiffre *a1,*b1,*c1;

  /* dcompose en blocs de sorte que le nb de blocs soit proche   */
  /* d'une puissance de 2. Pour rmp1 il vaut mieux tre au dessus */
  /* pour rmp2,rmp3 et rmp4 il vaut mieux tre au dessous de 2^k  */
  switch(meth) {
  case 1: for (n1=n; n1>=n0; n1>>=1);  if (n1 == 0) n1++; p = (n+n1-1)/n1; break;
  case 2:
  case 3:
  case 4: for (n1=n; n1>=n0; n1>>=1); n1++; p = (n+n1-1)/n1; break;
  case 5: for (n1=n; n1>=n0; n1>>=1); n1++; p = (n+n1-1)/n1; break;
  }

  a1 = getmem(2*p*(n1+1)); expand(a1,a,2*n-1,2*p-1,n1);
  b1 = getmem(p*(n1+1));   expand(b1,b,n,p,n1);
  c1 = getmem(p*2*(n1+1));

  /* calcule le produit mdian par blocs */
  switch(meth) {
  case 1: bloc_rmp1(   c1, a1, b1, p, n1+1); break;
  case 2: bloc_rmp2(   c1, a1, b1, p, n1+1); break;
  case 3: bloc_rmp3(   c1, a1, b1, p, n1+1); break;
  case 4: bloc_rmp4(0, c1, a1, b1, p, n1+1); break;
  case 5: bloc_rmp5(   c1, a1, b1, p, n1+1); break;
  }

  /* frontire infrieure */
  if (n1>1) {
    longueur lg = n-3 - (p-1)*n1; /* largeur troncature           */
    chiffre t[3];                 /* somme des produits  retirer */
    longueur i,j,k,l;
    ndouble r;
    
    clearmem(t,3); 
    for (i=0, k=(p-1)*n1, j=k+lg; i < n; i++,j--) {

      /* high(a[j]b[i]) et a[j+1]b[i]  retrancher */
      if (j+1 >= k) {
	r = aa(j+1)*bb(i) + (t[0] & mask);
	if (j >= k) r += ((aa(j)*bb(i)) >> shift);
	t[0] = r; r = (r >> shift) + (t[1] & mask);
	t[1] = r; r = (r >> shift) + (t[2] & mask);
	t[2] = r;
      }

      /* a[j+2]b[i] .. a[k-1]b[i]  ajouter */
      else if (j+2 < k) {
	for (l=j+2, r=0; l < k; l++) {
	  r += aa(l)*bb(i) + (c1[lg+l-j] & mask);
	  c1[lg+l-j] = r;
	  r >>= shift;
	}
	for (l=lg+k-j; (r) && (l < 2*n1+2); l++) {
	  r += c1[l] & mask;
	  c1[l] = r;
	  r >>= shift;
	}
      }

      /* changement de bloc */
      if ((i+1)%n1 == 0) k -= n1;
    }
    dec(c1+lg+1,t,2*n1-lg+1,3);
  }

  /* frontire suprieure */
  if (n1>1) {
    chiffre *c2 = c1 + 2*p + 2*n - 3; /* limite de troncature */
    longueur i,j,k,l;
    ndouble r,t;

    t = 0;
    for(i=0, k=(2*p-1)*n1, j=2*n-2; i < n; i++,j--) {

      /* a[k]b[i] .. a[j]b[i]  ajouter */
      if (j>=k) {
	for (l=k, r=0; l <= j; l++) {
	  r += aa(l)*bb(i) + (c2[l-j-1] & mask);
	  c2[l-j-1] = r;
	  r >>= shift;
	}
	r += c2[0] & mask; c2[0] = r; r >>= shift;
	r += c2[1] & mask; c2[1] = r;
      }

      /* a[j+1]b[i] et low(a[j+2]b[i])  retrancher */
      if ((i>0) && (j+1 < k)) {
	t += aa(j+1)*bb(i);
	if ((i>1) && (j+2 < k)) t += (aa(j+2)*bb(i)) << shift;
      }

      /* changement de bloc */
      if ((i+1)%n1 == 0) k -= n1;
    }
    t = (c2[0] & mask) + (c2[1] << shift) - t;
    c2[0] = t;
    c2[1] = t >> shift;
  }

  /* compacte le rsultat */
  { 
    longueur k = p*n1 - n + 1;
    compact(c+k, c1+2*(n1+1), p-1, 2*n1+2, n1, n+2-k);
    clearmem(c,k);
    inc(c,c1+n1-k,n+2, n1+2+k);
  }

  freemem(a1); freemem(b1); freemem(c1);
}

/* test */
double test_bloc_rmp(int meth, longueur n, longueur n0, int nrep, int check) {
  chiffre *a, *a1, *b, *b1, *c, *c1, *c2;
  longueur n1,p;
  int i;
  double t;

  a = random_bits(2*n-1);
  b = random_bits(n);
  c = getmem(n+2);

  if (check) {
    chiffre *d = getmem(n+2);

    rmp(meth,c,a,b,n,n0);
    muln2m(d,a,b,n);

    if (compare(c,d,n+2)) {
      fprintf(stderr,"multiplication fausse\n");
      fprintf(stderr,"a ="); dump(a,2*n-1);
      fprintf(stderr,"b ="); dump(b,n);
      fprintf(stderr,"c ="); dump(c,n+2);
      fprintf(stderr,"d ="); dump(d,n+2);
      fflush(stderr);
      exit(1);
    }
    t = 0;
    freemem(d);
  }

  else {
    chrono();
    for (i=0; i < nrep; i++) {
      rmp(meth,c,a,b,n,n0);
    }
    t = chrono()/nrep;
  }

  freemem(a); freemem(b); freemem(c);
  return(t);
}
