            /* +---------------------------------------+
               |  Test des algorithmes multiprcision  |
               +---------------------------------------+ */

#include "defs.h"


#define t_kara       0
#define t_kara_sq    1
#define t_bloc_kara  2
#define t_mlow       3
#define t_mhigh      4
#define t_rmp1       5
#define t_rmp2       6
#define t_rmp3       7
#define t_rmp4       8
#define t_rmp5       9
#define t_burnikel  10
#define t_burn_nr   11
#define t_burn_ex   12
#define t_rmpdiv    13
#define t_rmpdiv_nr 14
#define t_rmpdiv_ex 15
#define t_sqrt      16
#define t_sqrt_nr   17
#define t_sqrt_ex   18

int main(int argc, char **argv) {
  
  int nrep    = 100;       /* nombre de rptitions */
  int minsize = 10;        /* plage de test         */
  int maxsize = 20;
  int n0      = 32;        /* taille des blocs      */
  int test    = t_kara;    /* tests  effectuer     */
  int check   = 0;         /* contrle              */

  longueur n;
  double t;

  /* analyse la ligne de commande */
  argc--; argv++;
  while (argc) {
    if      (!strcmp(*argv,"-nrep")) {argv++; argc--; nrep    = atoi(*argv);}
    else if (!strcmp(*argv,"-min"))  {argv++; argc--; minsize = atoi(*argv);}
    else if (!strcmp(*argv,"-max"))  {argv++; argc--; maxsize = atoi(*argv);}
    else if (!strcmp(*argv,"-n"))    {argv++; argc--; maxsize = atoi(*argv); minsize=maxsize;}
    else if (!strcmp(*argv,"-n0"))   {argv++; argc--; n0      = atoi(*argv);}
    else if (!strcmp(*argv,"-check"))           {check = 1;}
    else if (!strcmp(*argv,"-karatsuba"))       {test  = t_kara;}
    else if (!strcmp(*argv,"-karasquare"))      {test  = t_kara_sq;}
    else if (!strcmp(*argv,"-bloc_karatsuba"))  {test  = t_bloc_kara;}
    else if (!strcmp(*argv,"-mulders_low"))     {test  = t_mlow;}
    else if (!strcmp(*argv,"-mulders_high"))    {test  = t_mhigh;}
    else if (!strcmp(*argv,"-rmp1"))            {test  = t_rmp1;}
    else if (!strcmp(*argv,"-rmp2"))            {test  = t_rmp2;}
    else if (!strcmp(*argv,"-rmp3"))            {test  = t_rmp3;}
    else if (!strcmp(*argv,"-rmp4"))            {test  = t_rmp4;}
    else if (!strcmp(*argv,"-rmp5"))            {test  = t_rmp5;}
    else if (!strcmp(*argv,"-burnikel"))        {test  = t_burnikel;}
    else if (!strcmp(*argv,"-burnikel_nr"))     {test  = t_burn_nr;}
    else if (!strcmp(*argv,"-burnikel_ex"))     {test  = t_burn_ex;}
    else if (!strcmp(*argv,"-rmpdiv"))          {test  = t_rmpdiv;}
    else if (!strcmp(*argv,"-rmpdiv_nr"))       {test  = t_rmpdiv_nr;}
    else if (!strcmp(*argv,"-rmpdiv_ex"))       {test  = t_rmpdiv_ex;}
    else if (!strcmp(*argv,"-sqrt"))            {test  = t_sqrt;}
    else if (!strcmp(*argv,"-sqrt_nr"))         {test  = t_sqrt_nr;}
    else if (!strcmp(*argv,"-sqrt_ex"))         {test  = t_sqrt_ex;}
    else {
      if (strcmp(*argv,"-h")) fprintf(stderr,"option non reconnue : %s\n",*argv);
      fprintf(stderr,"syntaxe : tests [-h] [-check]\n");
      fprintf(stderr,"                [-nrep k] [-min a] [-max b] [-n n] [-n0 n0]\n");
      fprintf(stderr,"                [-karatsuba] [-karasquare] [-bloc_karatsuba]\n");
      fprintf(stderr,"                [-mulders_low] [-mulders_high]\n");
      fprintf(stderr,"                [-rmp1] [-rmp2] [-rmp3] [-rmp4] [-rmp5]\n");
      fprintf(stderr,"                [-burnikel] [-burnikel_nr] [-burnikel_ex]\n");
      fprintf(stderr,"                [-rmpdiv] [-rmpdiv_nr] [-rmpdiv_ex]\n");
      fprintf(stderr,"                [-sqrt] [-sqrt_nr] [-sqrt_ex]\n");
      fflush(stderr);
      exit(1);
    }
    argv++; argc--;}

  /* affiche les paramtres pour contrle */
  switch(test) {
  case t_kara:      printf("test = karatsuba\n");      break;
  case t_kara_sq:   printf("test = karasquare\n");     break;
  case t_bloc_kara: printf("test = bloc_karatsuba\n"); break;
  case t_mlow:      printf("test = mulders_low\n");    break;
  case t_mhigh:     printf("test = mulders_high\n");   break;
  case t_rmp1:      printf("test = rmp1\n");           break;
  case t_rmp2:      printf("test = rmp2\n");           break;
  case t_rmp3:      printf("test = rmp3\n");           break;
  case t_rmp4:      printf("test = rmp4\n");           break;
  case t_rmp5:      printf("test = rmp5\n");           break;
  case t_burnikel:  printf("test = burnikel\n");       break;
  case t_burn_nr:   printf("test = burnikel_nr\n");    break;
  case t_burn_ex:   printf("test = burnikel_ex\n");    break;
  case t_rmpdiv:    printf("test = rmpdiv\n");         break;
  case t_rmpdiv_nr: printf("test = rmpdiv_nr\n");      break;
  case t_rmpdiv_ex: printf("test = rmpdiv_ex\n");      break;
  case t_sqrt:      printf("test = sqrt\n");           break;
  case t_sqrt_nr:   printf("test = sqrt_nr\n");        break;
  case t_sqrt_ex:   printf("test = sqrt_ex\n");        break;
  }
  printf("n0   = %d\n",n0);
  printf("min  = %d\n",minsize);
  printf("max  = %d\n",maxsize);
  printf("nrep = %d\n",nrep);

  /* excute les tests demands */
  for (n=minsize; n <= maxsize; n++) {
    switch(test) {
    case t_kara:      t = test_karatsuba(     n,n0,nrep,check); break;
    case t_kara_sq:   t = test_karasquare(    n,n0,nrep,check); break;
    case t_bloc_kara: t = test_bloc_karatsuba(n,n0,nrep,check); break;
    case t_mlow:      t = test_mulders(1,     n,n0,nrep,check); break;
    case t_mhigh:     t = test_mulders(2,     n,n0,nrep,check); break;
    case t_rmp1:      t = test_bloc_rmp(1,    n,n0,nrep,check); break;
    case t_rmp2:      t = test_bloc_rmp(2,    n,n0,nrep,check); break;
    case t_rmp3:      t = test_bloc_rmp(3,    n,n0,nrep,check); break;
    case t_rmp4:      t = test_bloc_rmp(4,    n,n0,nrep,check); break;
    case t_rmp5:      t = test_bloc_rmp(5,    n,n0,nrep,check); break;
    case t_burnikel:  t = test_burnikel(1,    n,n0,nrep,check); break;
    case t_burn_nr:   t = test_burnikel(0,    n,n0,nrep,check); break;
    case t_burn_ex:   t = test_burnikel(-1,   n,n0,nrep,check); break;
    case t_rmpdiv:    t = test_rmpdiv(1,      n,n0,nrep,check); break;
    case t_rmpdiv_nr: t = test_rmpdiv(0,      n,n0,nrep,check); break;
    case t_rmpdiv_ex: t = test_rmpdiv(-1,     n,n0,nrep,check); break;
    case t_sqrt:      t = test_sqrt(1,        n,n0,nrep,check); break;
    case t_sqrt_nr:   t = test_sqrt(0,        n,n0,nrep,check); break;
    case t_sqrt_ex:   t = test_sqrt(-1,       n,n0,nrep,check); break;
    }
    fprintf(stdout,"%d, %6.3f\n", n,t);
  }

  fflush(stdout);
  return(0);
}
