                        /* +---------------+
                           |  Utilitaires  |
                           +---------------+ */


#include <time.h>
#include <sys/times.h>
#include "defs.h"

/* mesure le temps en milisecondes */
double chrono() {
  static double tlast = 0;
  double t;
  struct tms buf;

  times(&buf);
  t = tlast;
  tlast = (double)(buf.tms_utime + buf.tms_stime)*1000/CLK_TCK;
  return(tlast - t);
}

/* affichage hexadcimal */
void dump(chiffre *a, longueur n) {
  longueur i;
  for (i=n-1; i >= 0; i--) {
#if shift==16
    fprintf(stderr,"%04X",aa(i));
#else
#if shift==32
    fprintf(stderr,"%08X",aa(i));
#else
    fprintf(stderr," %X",aa(i));
#endif
#endif
  }
  fprintf(stderr,"\n");
}

void bloc_dump(chiffre *a, longueur n, longueur n0) {
  longueur i,j;
  for (i=n-1; i >= 0; i--) {
    for (j=n0-1; j >= 0; j--) {
#if shift==16
      fprintf(stderr,"%04X",aa(i*n0+j));
#else
#if shift==32
      fprintf(stderr,"%08X",aa(i*n0+j));
#else
      fprintf(stderr," %X",aa(i*n0+j));
#endif
#endif
    }
    if (i > 0) fprintf(stderr," "); else fprintf(stderr,"\n");
  }
}

/* initialisation  partir d'une chane hexadcimale */
chiffre *from_string(char *s, longueur n) {
  chiffre *a = getmem(n);
  ndouble x;
  longueur i;
  int l = strlen(s);

  clearmem(a,n);
  s += l;
  x = 1 << shift;
  i = 0;
  while ((l > 0) && (i < n)) {
    s--; l--;
    if (*s <= '9')      x += ((*s - '0')      << (shift+1));
    else if (*s <= 'F') x += ((*s - 'A' + 10) << (shift+1));
    else                x += ((*s - 'a' + 10) << (shift+1));
    x >>= 4;
    if (x&1) {a[i++] = x >> 1; x = 1 << shift;}
  }
  if (i < n) {
    while ((x&1) == 0) x >>= 4;
    a[i] = x >>= 1;
  }
  return(a);
}

/* initialisation alatoire */
chiffre *random_bits(longueur n) {
  chiffre *a = getmem(n);
  longueur i;

  for (i=0; i < n; a[i++] = random());
  return(a);
}


/* compare a et b */
int compare(chiffre *a, chiffre *b, longueur n) {
  int i;
  for (i=n-1; (i>=0) && (aa(i) == bb(i)); i--);
  return((i<0) ? 0 : (aa(i)>bb(i)) ? 1 : -1);
}


